check_level = 0
action_state = false

------------------------------------------ event script
script.on_event(defines.events.on_tick, function(event)
	if event.tick%60 == 0 then
		-- writeDebug("tick = " .. event.tick)
		if global.Roboport_Table ~= nil then
			for _,entity in pairs(global.Roboport_Table) do
				if not entity[1].valid then
					table.remove(global.Roboport_Table, _)
				end
				if #global.Roboport_Table == 0 then
					global.Roboport_Table = nil
				end
				-- writeDebug("remove roboport" .. #global.Roboport_Table)
			end
			-- writeDebug(#global.Roboport_Table)
		end
	end
	if event.tick%20 == 0 then
		if action_state then
			if global.Roboport_Table ~= nil then
				-- writeDebug("Roboport_Table not nil")
				local numb = 3
				local top = #global.Roboport_Table - (numb * check_level)
				local bottom = #global.Roboport_Table - numb - (numb * check_level)
				local caption_text
				-- writeDebug(top .. " / " .. bottom .. " / " .. check_level)
				check_level = check_level + 1
				for i = top, bottom, -1 do
					if i <= 0 then
						check_level = 0
						action_state = false
						caption_text = 0
						break
					end
					if global.Roboport_Table[i] then scan_item(global.Roboport_Table[i]) end
					caption_text = i
				end
				for _, player in pairs(game.players) do
					if player.gui.left["collect_title"] then
						player.gui.left["collect_title"].collect_button_table.collect_button_table_2.caption = string.format("   %d %s ", ((#global.Roboport_Table-caption_text)/#global.Roboport_Table*100), "%")
					end
				end
			end
		else
			for _, player in pairs(game.players) do
				if player.gui.left["collect_title"] then
					player.gui.left["collect_title"].destroy()
				end
			end
		end
	end
end)

script.on_event({defines.events.on_built_entity,}, function(event) On_Built(event) end)
script.on_event({defines.events.on_robot_built_entity,}, function(event) On_Built(event) end)

script.on_event("item_explorer", function(event)
	progress_button(game.players[event.player_index])
end)


------------------------------------------ scan function
function On_Built(event)
	if event.created_entity.type == "roboport" then
		if global.Roboport_Table == nil then
			global.Roboport_Table = {}
		end
		local radius = event.created_entity.logistic_cell.construction_radius
		-- writeDebug(radius)
		
		if radius > 100 then
			radius = 100
		end
		if radius >= 10 then
			table.insert(global.Roboport_Table, {event.created_entity, radius})
		end
		-- writeDebug("add roboport")
	end
end

function scan_item(entity)
	if entity[1].valid then
		local force = entity[1].force
		local items = entity[1].surface.find_entities_filtered{area = {{entity[1].position.x-entity[2], entity[1].position.y-entity[2]}, {entity[1].position.x+entity[2], entity[1].position.y+entity[2]}}, name = "item-on-ground"}
		for _, item in ipairs(items) do
			if not item.to_be_deconstructed(force) then 
				item.order_deconstruction(force)
				-- writeDebug("scan items")
			end
		end
	end
end


------------------------------------------ button
function progress_button(player)
	local true_frame = player.gui.left["collect_title"]
	local false_frame = player.gui.left["collect_false_title"]
	if not (true_frame or false_frame) then
		if player.force.technologies["automated-construction"].researched then
			if global.Roboport_Table then
				true_frame = player.gui.left.add{type="frame", name="collect_title"}
				local true_table = true_frame.add{type = "table", name = "collect_button_table", colspan = 2}
				true_table.add{type = "label", name = "collect_button_table_1", caption = "Scanning area near Roboport."}
				true_table.add{type = "label", name = "collect_button_table_2", caption = "   0 % "}
				action_state = true
			end
		else
			false_frame = player.gui.left.add{type="frame", name="collect_false_title"}
			local false_table = false_frame.add{type = "table", name = "collect_false_button_table", colspan = 2}
			
			false_table.add{type = "label", name = "collect_false_button_table_1", caption = "Need to develop : "}
			false_table.add{type = "label", name = "collect_false_button_table_2", caption = player.force.technologies["automated-construction"].localised_name}
		end
	elseif false_frame then
		false_frame.destroy()
	end
end


------------------------------------------ bundle
function writeDebug(message)
	for i, player in pairs(game.players) do
		player.print(tostring(message))
	end
end